public class LinkedListEnd {

    class ListNode {

        ListNode next;
        Object item;

        ListNode(Object item) {
            this.item = item;
            next = null;
        }
    }

    private ListNode start;
    private ListNode end;

    public LinkedListEnd() {
        start = null;
    }

    public LinkedListEnd push(Object obj) {
        ListNode node = new ListNode(obj);
        if (start == null) {
            start = end = node;
        } else {
            node.next = start;
            start = node;
        }
        return this;
    }

    public Object pop() {
        Object ret = null;
        if (start != null) {
            ret = start.item;
            start = start.next;
            if (start == null) {
                end = null;
            }
        }
        return ret;
    }

    public int size() {
        int count = 0;
        ListNode cur = start;
        while (cur != null) {
            cur = cur.next;
            count++;
        }
        return count;
    }

    public Object back() {
        ListNode end = start;
        while (end != null && end.next != null) {
            end = end.next;
        }
        return end == null ? null : end.item;
    }

    public LinkedListEnd pushEnd(Object obj) {
        ListNode node = new ListNode(obj);
        if (end == null) {
            start = end = node;
        } else {
            end.next = node;
            end = node;
        }
        return this;
    }

    public Object popEnd() {
        if (start == null) {
            return null;
        }
        Object ret = end.item;
        if (start == end) {
            start = end = null;
        } else {
            ListNode cur = start;
            while (cur.next != end) {
                cur = cur.next;
            }
            end = cur;
            end.next = null;
        }
        return ret;
    }

    public void print() {
        ListNode cur = start;
        while (cur != null) {
            System.out.print(cur.item + (cur.next == null ? "\n" : " "));
            cur = cur.next;
        }
    }
}
